rules:
  - id: skeleton-loader-class-vue
    patterns:
      - pattern-regex: gl-skeleton-loader
      - pattern-not-regex: </?gl-skeleton-loader
      - pattern-not-inside: createElement(...)
    message: |
      Detected usage of `gl-skeleton-loader` class inside JS/Vue file.
      Please use the GlSkeletonLoader component from `@gitlab/ui`.
    languages:
      - generic
    severity: ERROR
    paths:
      include:
        - '*.js'
        - '*.vue'
    metadata:
      needsEpicOrWarning: true
      componentLabel: 'component:skeleton-loader'
      pajamasCompliant: false

  - id: okay-skeleton-loader-vue-component
    patterns:
      - pattern-inside: import ... ... from '@gitlab/ui'
      - pattern: GlSkeletonLoader
    message: Correct usage of GlSkeletonLoader gitlab-ui component.
    languages:
      - generic
    severity: INFO
    paths:
      include:
        - '*.js'
        - '*.vue'
    metadata:
      componentLabel: 'component:skeleton-loader'
      pajamasCompliant: true
